SystemOrganization addCategory: #GhostProxies!

!CompiledMethod methodsFor: '*GhostProxies' stamp: 'MarianoMartinezPeck 4/20/2011 15:57'!
executeWithReceiver: aReceiver arguments: anArray 
 "Execute compiledMethod against the receiver and args in argArray. The receiver is the CompiledMethod"

<primitive: 190>
   self primitiveFailed! !

Object subclass: #ClassProxy
	instanceVariableNames: 'target handler superclass methodDict format'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GhostProxies'!

!ClassProxy classSide methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 4/21/2011 11:52'!
createProxyAndReplace: aClass
   | aProxy newProxyRef newClassRef|
       aProxy := self new
		initializeWith: SimpleForwarderHandler new
       	methodDict: nil
       	superclass: ClassProxy
       	format: ClassProxy format.
       aProxy become: aClass.
        "After the become is done, aProxy now points to aClass 
        and aClass points to aProxy. We create two new variables
         just to clarify the code"
       newProxyRef := aClass.
       newClassRef := aProxy.
       newProxyRef target: newClassRef.
       ClassProxyTrap adoptInstance: newProxyRef.
       ^ newProxyRef.
! !

!ClassProxy methodsFor: 'as yet unclassified' stamp: 'Mariano 5/24/2011 11:17'!
cannotInterpret: aMessage
	Transcript show: 'cannotInterpret message: ', aMessage selector.
	(ClassProxyTrap = aMessage lookupClass )
		ifTrue: [^ handler handleInterception: aMessage for: target proxy: self]
		"This is broken and doesnt work because the bytecode of this compiled method to access handler will access another slot"
		ifFalse: [ ^ handler handleInterceptionToInstance: aMessage for: target andReceiver: self
]       ! !

!ClassProxy methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 4/21/2011 11:53'!
initializeWith: aHandler methodDict: aMethodDict superclass: aClass format: aFormat
	super initialize.
	handler := aHandler.
	methodDict := aMethodDict.
	superclass := aClass.
	format := aFormat.! !

!ClassProxy methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 4/20/2011 13:53'!
target: anObject
	target := anObject! !

ClassProxy subclass: #ClassProxyTrap
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GhostProxies'!

!ClassProxyTrap classSide methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 4/20/2011 13:30'!
initialize
	superclass := ClassProxy.
	format := ClassProxy format.
	methodDict := nil.! !

Object subclass: #Interception
	instanceVariableNames: 'message receiver target proxy'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GhostProxies'!

!Interception classSide methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 4/21/2011 13:53'!
for: aMessage target: aTargetObject proxy: aProxy receiver: aReceiver
	^ self new initializewith: aMessage 
		target: aTargetObject
		proxy: aProxy 
		receiver: aReceiver ! !

!Interception methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 4/21/2011 13:39'!
initializewith: aMessage target: aTargetObject proxy: aProxy  receiver: aReceiver 
	message := aMessage.
	target := aTargetObject.
	proxy := aProxy.
	receiver := aReceiver.! !

!Interception methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 4/21/2011 13:52'!
message
	^ message! !

!Interception methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 4/21/2011 13:52'!
message: anObject
	message := anObject! !

!Interception methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 4/21/2011 13:52'!
proxy
	^ proxy! !

!Interception methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 4/21/2011 13:52'!
proxy: anObject
	proxy := anObject! !

!Interception methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 4/21/2011 13:52'!
receiver
	^ receiver! !

!Interception methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 4/21/2011 13:52'!
receiver: anObject
	receiver := anObject! !

!Interception methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 4/21/2011 13:52'!
target
	^ target! !

!Interception methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 4/21/2011 13:52'!
target: anObject
	target := anObject! !

Object subclass: #ObjectProxy
	instanceVariableNames: 'target handler'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GhostProxies'!

!ObjectProxy classSide methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 4/22/2011 16:24'!
createProxyAndReplace: anObject
   | aProxy newProxyRef newObjectRef|
       aProxy := self new
		initializeWith: anObject
		handler: SimpleForwarderHandler new. 
       aProxy become: anObject.
        "After the become is done, aProxy now points to anObject 
        and anObject points to aProxy. We create two new variables
         just to clarify the code"
       newProxyRef := anObject.
       newObjectRef := aProxy.
       newProxyRef target: newObjectRef.
       ObjectProxyTrap adoptInstance: newProxyRef.
       ^ newProxyRef.
! !

!ObjectProxy classSide methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 4/22/2011 16:30'!
createProxyAndReplaceMethod: aMethod
	 | aProxy |
       aProxy := self new
		initializeWith: aMethod
		handler: SimpleForwarderHandler new. 
	aMethod methodClass methodDict at: aMethod selector put: aProxy.
	 ObjectProxyTrap initialize.
       ObjectProxyTrap adoptInstance: aProxy.
       ^ aProxy.! !

!ObjectProxy classSide methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 4/21/2011 11:55'!
proxyFor: anObject
	 | aProxy |
       aProxy := self new
		initializeWith: anObject
		handler: SimpleForwarderHandler new. 
	 ObjectProxyTrap initialize.
       ObjectProxyTrap adoptInstance: aProxy.
       ^ aProxy.! !

!ObjectProxy methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 4/20/2011 13:46'!
cannotInterpret: aMessage
       ^ handler handleInterception: aMessage for: target proxy: self! !

!ObjectProxy methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 4/21/2011 11:56'!
initializeWith: anObject handler: aHandler
	target := anObject.
	handler := aHandler  
	! !

!ObjectProxy methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 4/22/2011 16:29'!
target: aTargetObject
	target := aTargetObject ! !

ObjectProxy subclass: #ObjectProxyTrap
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GhostProxies'!

!ObjectProxyTrap classSide methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 4/20/2011 10:58'!
initialize
	superclass := ObjectProxy.
	format := ObjectProxy format.
	methodDict := nil.! !

Object subclass: #SimpleForwarderHandler
	instanceVariableNames: 'methodsNotToIntercept'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GhostProxies'!

!SimpleForwarderHandler methodsFor: 'handle - debugging' stamp: 'MarianoMartinezPeck 4/22/2011 11:17'!
debuggingMessagesToHandle
	| dict |
	dict := Dictionary new.
	dict at: #basicInspect put:#handleBasicInspect:.
	dict at: #inspect put:#handleInspect:.
	dict at: #inspectorClass put:#handleInspectorClass:.
	dict at: #defaultLabelForInspector put:#handleDefaultLabelForInspector:.
	dict at: #printStringLimitedTo: put: #handlePrintStringLimitedTo:.
	dict at: #printString put: #handlePrintString:.
	dict at: #longPrintOn:limitedTo:indent: put: #handleLongPrintOnLimitedToIndent:.
	^ dict	! !

!SimpleForwarderHandler methodsFor: 'private' stamp: 'MarianoMartinezPeck 4/22/2011 11:10'!
defaultMethodsNotToIntercept
	| dict |
	dict := Dictionary new.
	dict addAll: self methodsMessagesToHandle.
	dict addAll: self debuggingMessagesToHandle.
	dict addAll: self testSupportMessagesToHandle.
	^ dict
	
	! !

!SimpleForwarderHandler methodsFor: 'handle - debugging' stamp: 'MarianoMartinezPeck 4/22/2011 11:13'!
handleBasicInspect: anInterception
	"Create and schedule an Inspector in which the user can examine the 
	receiver's variables. This method should not be overriden."
	^ToolSet basicInspect: anInterception proxy! !

!SimpleForwarderHandler methodsFor: 'handle - debugging' stamp: 'MarianoMartinezPeck 4/22/2011 11:13'!
handleDefaultLabelForInspector: anInterception
	^ 'Proxy'! !

!SimpleForwarderHandler methodsFor: 'handle - methods' stamp: 'MarianoMartinezPeck 4/22/2011 11:11'!
handleFlushCache: anInterception
	^ anInterception target selector flushCache	 
		! !

!SimpleForwarderHandler methodsFor: 'handle - debugging' stamp: 'MarianoMartinezPeck 4/22/2011 11:08'!
handleInspect: anInterception
	"Create and schedule an Inspector in which the user can examine the receiver's variables."
	ToolSet inspect: anInterception proxy! !

!SimpleForwarderHandler methodsFor: 'handle - debugging' stamp: 'MarianoMartinezPeck 4/22/2011 11:08'!
handleInspectorClass: anInterception
	"Answer the class of the inspector to be used on the receiver.  Called by inspect; 
	use basicInspect to get a normal (less useful) type of inspector."

	^ Inspector! !

!SimpleForwarderHandler methodsFor: 'handle - API' stamp: 'MarianoMartinezPeck 4/22/2011 11:01'!
handleInterception: aMessage for: aTargetObject proxy: proxy
	| interception |	
	Transcript show: 'message ', aMessage selector, ' intercepted'; cr.
	interception := Interception for: aMessage target: aTargetObject proxy: proxy receiver: nil. 
	(self isMessageNotToIntercept: aMessage)
		ifTrue: [ ^ self manageMessageInternally: interception ]
	 	ifFalse: [ ^ self manageMessage: interception  ]! !

!SimpleForwarderHandler methodsFor: 'handle - API' stamp: 'MarianoMartinezPeck 4/20/2011 15:59'!
handleInterceptionToInstance: aMessage for: aClass andReceiver: anInstance

	Transcript show: 'message ', aMessage selector, ' to instance intercepted and will be forwarded'; cr.
	^ (aClass lookupSelector: aMessage selector) 
		executeWithReceiver: anInstance arguments: aMessage arguments 
	! !

!SimpleForwarderHandler methodsFor: 'handle - debugging' stamp: 'MarianoMartinezPeck 4/22/2011 11:08'!
handleLongPrintOnLimitedToIndent: anInterception
	! !

!SimpleForwarderHandler methodsFor: 'handle - debugging' stamp: 'MarianoMartinezPeck 4/22/2011 11:09'!
handleLongPrintStringLimitedTo: anInterception
	^ 'This is a proxy'! !

!SimpleForwarderHandler methodsFor: 'handle - methods' stamp: 'MarianoMartinezPeck 4/21/2011 13:46'!
handleMethodExecution: anInterception
	Transcript show: 'message ', anInterception message selector, ' execution intercepted and will be forwarded'; cr.
	^ anInterception target valueWithReceiver: anInterception message arguments third arguments: anInterception message arguments second
	
! !

!SimpleForwarderHandler methodsFor: 'handle - debugging' stamp: 'MarianoMartinezPeck 4/22/2011 11:31'!
handlePrintOn: anInterception
	anInterception message arguments first nextPutAll: 'aProxy'  ! !

!SimpleForwarderHandler methodsFor: 'handle - debugging' stamp: 'MarianoMartinezPeck 4/22/2011 11:09'!
handlePrintString: anInterception
	^ anInterception proxy printStringLimitedTo: 50000! !

!SimpleForwarderHandler methodsFor: 'handle - debugging' stamp: 'MarianoMartinezPeck 4/22/2011 11:09'!
handlePrintStringLimitedTo: anInterception
	^ 'This is the print of a proxy'! !

!SimpleForwarderHandler methodsFor: 'handle - support' stamp: 'MarianoMartinezPeck 4/22/2011 11:09'!
handleUninstall: anInterception

	Transcript show: 'message ', anInterception message selector, ' received and the proxy will be uninstalled'; cr.
	^ anInterception target become: anInterception proxy.
	! !

!SimpleForwarderHandler methodsFor: 'private' stamp: 'MarianoMartinezPeck 4/21/2011 13:48'!
isMessageNotToIntercept: aMessage
	^ self methodsNotToIntercept includesKey: aMessage selector  ! !

!SimpleForwarderHandler methodsFor: 'private' stamp: 'MarianoMartinezPeck 4/22/2011 11:01'!
manageMessage: interception
	Transcript show: 'The method ', interception message selector, ' will beforwarded'; cr.
	^ interception message sendTo: interception target! !

!SimpleForwarderHandler methodsFor: 'private' stamp: 'MarianoMartinezPeck 4/22/2011 11:01'!
manageMessageInternally: anInterception 
	Transcript show: 'The method ', anInterception message selector, ' will NOT be forwarded by instead answer by the handler'; cr.
	^ self perform: (self methodsNotToIntercept at: anInterception message selector) with: anInterception ! !

!SimpleForwarderHandler methodsFor: 'handle - methods' stamp: 'MarianoMartinezPeck 4/22/2011 11:27'!
methodsMessagesToHandle
	| dict |
	dict := Dictionary new.
	dict at: #flushCache put: #handleFlushCache:.
	dict at: #run:with:in: put: #handleMethodExecution:.
	^ dict
! !

!SimpleForwarderHandler methodsFor: 'private' stamp: 'MarianoMartinezPeck 4/21/2011 13:29'!
methodsNotToIntercept
	methodsNotToIntercept isNil ifTrue: [ methodsNotToIntercept := self defaultMethodsNotToIntercept ].
	^ methodsNotToIntercept ! !

!SimpleForwarderHandler methodsFor: 'handle - support' stamp: 'MarianoMartinezPeck 4/22/2011 11:18'!
testSupportMessagesToHandle
	| dict |
	dict := Dictionary new.
	dict at: #uninstall put: #handleUninstall:.
	^ dict 
	! !
ClassProxyTrap initialize!
ObjectProxyTrap initialize!
